Index: trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/m_elstack.f90
===================================================================
--- trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/m_elstack.f90	(revision 2528)
+++ trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/m_elstack.f90	(revision 2528)
@@ -0,0 +1,153 @@
+module m_elstack
+
+use m_buffer
+
+private
+
+!
+! Simple stack to keep track of which elements have appeared so far
+!
+integer, parameter, private            :: STACK_SIZE = 40
+
+type, public :: elstack_t
+private
+      integer                                :: n_items
+      type(buffer_t), dimension(STACK_SIZE)  :: data
+end type elstack_t
+
+public  :: push_elstack, pop_elstack, reset_elstack, print_elstack
+public  :: init_elstack
+public  :: get_top_elstack, is_empty, get_elstack_signature
+
+interface is_empty
+      module procedure is_empty_elstack
+end interface
+private :: is_empty_elstack
+
+CONTAINS
+
+!-----------------------------------------------------------------
+subroutine init_elstack(elstack)
+type(elstack_t), intent(inout)  :: elstack
+
+integer :: i
+
+elstack%n_items = 0
+do i = 1, STACK_SIZE                   ! to avoid "undefined status"
+      call init_buffer(elstack%data(i))
+enddo
+end subroutine init_elstack
+
+!-----------------------------------------------------------------
+subroutine reset_elstack(elstack)
+type(elstack_t), intent(inout)  :: elstack
+
+integer :: i
+
+elstack%n_items = 0
+do i = 1, STACK_SIZE                  
+      call reset_buffer(elstack%data(i))
+enddo
+end subroutine reset_elstack
+
+!-----------------------------------------------------------------
+function is_empty_elstack(elstack) result(answer)
+type(elstack_t), intent(in)  :: elstack
+logical                    :: answer
+
+answer = (elstack%n_items == 0)
+end function is_empty_elstack
+
+!-----------------------------------------------------------------
+subroutine push_elstack(item,elstack)
+type(buffer_t), intent(in)      :: item
+type(elstack_t), intent(inout)  :: elstack
+
+integer   :: n
+
+n = elstack%n_items
+if (n == STACK_SIZE) then
+      stop "*Element stack full"
+endif
+n = n + 1
+elstack%data(n) = item
+elstack%n_items = n
+
+end subroutine push_elstack
+
+!-----------------------------------------------------------------
+subroutine pop_elstack(elstack,item)
+type(elstack_t), intent(inout)     :: elstack
+type(buffer_t), intent(out)        :: item
+
+!
+! We assume the elstack is not empty... (the user has called is_empty first)
+!
+integer   :: n
+
+n = elstack%n_items
+if (n == 0) then
+      stop "*********Element stack empty"
+endif
+item = elstack%data(n)
+elstack%n_items = n - 1
+
+end subroutine pop_elstack
+
+!-----------------------------------------------------------------
+subroutine get_top_elstack(elstack,item)
+!
+! Get the top element of the stack, *without popping it*.
+!
+type(elstack_t), intent(in)        :: elstack
+type(buffer_t), intent(out)        :: item
+
+!
+! We assume the elstack is not empty... (the user has called is_empty first)
+!
+integer   :: n
+
+n = elstack%n_items
+if (n == 0) then
+      stop "*********Element stack empty"
+endif
+item = elstack%data(n)
+
+end subroutine get_top_elstack
+
+!-----------------------------------------------------------------
+subroutine print_elstack(elstack,unit)
+type(elstack_t), intent(in)   :: elstack
+integer, intent(in)           :: unit
+integer   :: i
+
+do i = elstack%n_items, 1, -1
+      write(unit=unit,fmt=*) str(elstack%data(i))
+enddo
+
+end subroutine print_elstack
+
+!-------------------------------------------------------------
+subroutine get_elstack_signature(elstack,string)
+type(elstack_t), intent(in)   :: elstack
+character(len=*), intent(out) :: string
+integer   :: i, length, j
+
+string = ""
+j = 0
+do i = 1, elstack%n_items
+   length = len(elstack%data(i))
+   string(j+1:j+1) = "/"
+   j = j+1
+   string(j+1:j+length) = str(elstack%data(i))
+   j = j + length
+enddo
+
+end subroutine get_elstack_signature
+
+end module m_elstack
+
+
+
+
+
Index: trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/m_entities.f90
===================================================================
--- trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/m_entities.f90	(revision 2528)
+++ trunk/NEMOGCM/EXTERNAL/XMLF90/src/sax/m_entities.f90	(revision 2528)
@@ -0,0 +1,134 @@
+module m_entities
+!
+! Entity management
+!
+! It deals with: 
+!    1. The five standard entities (gt,lt,amp,apos,quot)
+!    2. Character entities  (but only within the range of the char intrinsic)
+!
+use m_buffer
+private
+
+integer, parameter, private      :: MAX_REPLACEMENT_SIZE = 200
+!
+type, private :: entity_t
+ character(len=40)                     :: code
+ character(len=MAX_REPLACEMENT_SIZE)   :: replacement
+end type entity_t
+
+integer, parameter, private                          ::  N_ENTITIES  = 5
+
+type(entity_t), private, dimension(N_ENTITIES), save :: predefined_ent =  &
+      (/                  &
+      entity_t("gt",">"), &
+      entity_t("lt","<"),  &
+      entity_t("amp","&"),  &
+      entity_t("apos","'"),  &
+      entity_t("quot","""")  &
+      /)
+      
+public :: code_to_str , entity_filter
+
+CONTAINS
+
+subroutine code_to_str(code,str,status)
+character(len=*), intent(in)  :: code
+character(len=*), intent(out) :: str
+integer, intent(out)          :: status         
+integer :: i
+
+integer   :: number, ll
+character(len=4)  :: fmtstr
+
+status = -1
+do i = 1, N_ENTITIES
+      if (code == predefined_ent(i)%code) then
+         str = predefined_ent(i)%replacement
+         status = 0
+         return
+      endif
+enddo
+!
+! Replace character references  (but only within the range of the
+! char intrinsic !!)
+!
+if (code(1:1) == "#") then
+   if (code(2:2) == "x") then       ! hex character reference
+      ll = len_trim(code(3:))
+      write(unit=fmtstr,fmt="(a2,i1,a1)") "(Z", ll,")"
+      read(unit=code(3:),fmt=fmtstr) number
+      str = char(number)
+      status = 0
+      return
+   else                             ! decimal character reference
+      read(unit=code(2:),fmt=*) number
+      str = char(number)
+      status = 0
+      return
+   endif
+endif
+
+end subroutine code_to_str
+
+!----------------------------------------------------------------
+!
+! Replaces entity references in buf1 and creates a new buffer buf2.
+!
+subroutine entity_filter(buf1,buf2,status,message)
+type(buffer_t), intent(in)    :: buf1
+type(buffer_t), intent(out)   :: buf2
+integer, intent(out)          :: status
+character(len=*), intent(out) :: message
+!
+! Replaces entity references by their value
+!
+integer :: i, k, len1
+character(len=MAX_BUFF_SIZE)           :: s1
+character(len=1)                       :: c
+character(len=MAX_REPLACEMENT_SIZE)    :: repl
+
+call buffer_to_character(buf1,s1)        !! Avoid allocation of temporary
+len1 = len(buf1)
+
+i = 1
+status = 0
+
+call reset_buffer(buf2)
+
+do
+   if (i > len1) exit
+   c = s1(i:i)
+   if (c == "&") then
+      if (i+1 > len1) then
+         status = -i
+         message=  " Unmatched & in entity reference"
+         return
+      endif
+      k = index(s1(i+1:),";")
+      if (k == 0) then
+         status = -i
+         message=  " Unmatched & in entity reference"
+         return
+      endif
+      call code_to_str(s1(i+1:i+k-1),repl,status)
+      if (status /= 0) then
+         status =  i     ! Could let it continue
+         message= "Ignored unknown entity: &" // s1(i+1:i+k-1) // ";"
+      else
+         call add_to_buffer(trim(repl),buf2)
+      endif
+      i = i + k + 1
+   else
+     call add_to_buffer(c,buf2)
+     i = i + 1
+   endif
+enddo
+
+end subroutine entity_filter
+
+end module m_entities
+
+
+
+
+
